using System;
using System.Drawing;
using System.Reflection;
using System.Text;
using System.Windows.Forms;

using Smdn.Collections;

namespace Smdn.Applications.ThbgmExtractor {
  public partial class AboutDialog : Form {
    public AboutDialog()
    {
      InitializeComponent();

      var sb = new StringBuilder(1024);

      foreach (var pair in new[] {
        new {Assm = Assembly.GetEntryAssembly(), Url = "http://smdn.invisiblefulmoon.net/works/tools/ThbgmExtractor/"},
        new {Assm = Assembly.GetAssembly(typeof(TagLib.Tag)), Url = "http://developer.novell.com/wiki/index.php/TagLib_Sharp"},
      }) {
        sb.AppendFormat("{0} {1}", GetTitleFromAssembly(pair.Assm), pair.Assm.GetName().Version);
        sb.AppendLine();
        sb.AppendLine(GetCopyrightFromAssembly(pair.Assm));
        sb.AppendLine(pair.Url);
        sb.AppendLine();
      }

      textBoxAbout.Text = sb.ToString();
      textBoxAbout.Select(0, 0);
    }

    private string GetCopyrightFromAssembly(Assembly assm)
    {
      var copyright = assm.GetCustomAttributes(typeof(AssemblyCopyrightAttribute), false).FirstOrDefault() as AssemblyCopyrightAttribute;

      if (copyright == null)
        return string.Empty;
      else
        return copyright.Copyright;
    }

    private string GetTitleFromAssembly(Assembly assm)
    {
      var title = assm.GetCustomAttributes(typeof(AssemblyTitleAttribute), false).FirstOrDefault() as AssemblyTitleAttribute;

      if (title == null)
        return string.Empty;
      else
        return title.Title;
    }
  }
}
